SystemOrganization addCategory: 'OrbeonBizagiSvgConverter'!

!XPDLGatewayNode methodsFor: '*orbeonBizagiSvgConverter' stamp: 'BrunoBB 09/13/2016 13:20'!
drawOn: aJasvgiBpmCanvas

	^aJasvgiBpmCanvas drawGatewayType: type at: self getXcoordinate @ self getYcoordinate id: self getName color: 'lightgray'! !

!XPDLGatewayNode methodsFor: '*orbeonBizagiSvgConverter' stamp: 'BrunoBB 09/14/2016 10:07'!
drawOn: aJasvgiBpmCanvas color: color stroke: stroke 

	^aJasvgiBpmCanvas
		drawGatewayType: type
		at: self getXcoordinate @ self getYcoordinate 
		id: self getName
		color: color! !

!XPDLStartNode methodsFor: '*orbeonBizagiSvgConverter' stamp: 'brunobb 02/11/2018 14:26'!
drawOn: aJasvgiBpmCanvas

	^self isTimerNode
	ifTrue: [aJasvgiBpmCanvas drawTimeEvent: self at: (self getXcoordinate @ self getYcoordinate)]
	ifFalse: [aJasvgiBpmCanvas drawStartNamed: self getName at: self getXcoordinate @ self getYcoordinate]! !

!XPDLScriptNode methodsFor: '*orbeonBizagiSvgConverter' stamp: 'brunobb 08/01/2017 12:21'!
drawOn: aJasvgiBpmCanvas

	^aJasvgiBpmCanvas 
			drawScriptNamed: self getName 
			at: self getXcoordinate @ self getYcoordinate 
			extent: self getWidth @ self getHeight! !

!XPDLObject2 methodsFor: '*orbeonBizagiSvgConverter' stamp: 'BrunoBB 09/10/2016 08:23'!
drawOn: aJasvgiBpmCanvas! !

!XPDLObject2 methodsFor: '*orbeonBizagiSvgConverter' stamp: 'BrunoBB 09/13/2016 09:13'!
drawOn: aJasvgiBpmCanvas color: color! !

!XPDLObject2 methodsFor: '*orbeonBizagiSvgConverter' stamp: 'BrunoBB 09/14/2016 10:07'!
drawOn: aJasvgiBpmCanvas color: color stroke: stroke! !

!XPDLObject2 methodsFor: '*orbeonBizagiSvgConverter' stamp: 'BrunoBB 09/10/2016 14:25'!
getColor

	^(((xmlSegment findElementNamed: 'NodeGraphicsInfo') attributeAt: 'FillColor') = '-2517356')
		ifTrue: ['lightblue'] 
		ifFalse: ['lightgray']! !

!XPDLEventNode methodsFor: '*orbeonBizagiSvgConverter' stamp: 'brunobb 10/18/2017 14:11'!
drawOn: aJasvgiBpmCanvas

	self isTimerNode
	ifTrue: [aJasvgiBpmCanvas drawTimeEvent: self at: (self getXcoordinate @ self getYcoordinate)]
	ifFalse: [aJasvgiBpmCanvas drawEventNamed: self getName at: self getXcoordinate @ self getYcoordinate]! !

!XPDLEventNode methodsFor: '*orbeonBizagiSvgConverter' stamp: 'BrunoBB 09/14/2016 10:07'!
drawOn: aJasvgiBpmCanvas color: color stroke: stroke 

	^self drawOn: aJasvgiBpmCanvas! !

!XPDLEventNode methodsFor: '*orbeonBizagiSvgConverter' stamp: 'BrunoBB 09/13/2016 10:04'!
drawOn: aJasvgiBpmCanvas context: aBpmProcessInstance color: color stroke: stroke 

	^self drawOn: aJasvgiBpmCanvas! !

!XPDLLaneNode methodsFor: '*orbeonBizagiSvgConverter' stamp: 'BrunoBB 09/11/2016 08:55'!
drawOn: aJasvgiBpmCanvas

	^aJasvgiBpmCanvas
		drawLaneNamed: self getName 
		at: self getXcoordinate @ self getYcoordinate 
		width: self getWidth
		height: self getHeight! !

!XPDLActivityNode methodsFor: '*orbeonBizagiSvgConverter' stamp: 'BrunoBB 03/05/2017 09:19'!
drawOn: aJasvgiBpmCanvas

	self isMultiInstance 
	ifFalse: [^aJasvgiBpmCanvas 
						drawActivityNamed: self getName 
						at: self getXcoordinate @ self getYcoordinate 
						extent: self getWidth @ self getHeight].

	^aJasvgiBpmCanvas 
			drawMultiInstaceActivityNamed: self getName 
			at: self getXcoordinate @ self getYcoordinate 
			extent: self getWidth @ self getHeight! !

!XPDLActivityNode methodsFor: '*orbeonBizagiSvgConverter' stamp: 'BrunoBB 03/05/2017 09:19'!
drawOn: aJasvgiBpmCanvas color: color stroke: stroke 

	^aJasvgiBpmCanvas
		drawActivityNamed: self getName 
		at: self getXcoordinate @ self getYcoordinate
		extent: self getWidth @ self getHeight
		color: color
		stroke: stroke! !

!XPDLTransitionNode methodsFor: '*orbeonBizagiSvgConverter' stamp: 'brunobb 02/11/2018 14:32'!
drawOn: aJasvgiBpmCanvas
	| transition |

	transition := 
		aJasvgiBpmCanvas 
			connectWith: coordinates
			color: 'gray'
			widthPx: '1px'.

	startNode drawOn: aJasvgiBpmCanvas.
	endNode drawOn: aJasvgiBpmCanvas.

	transition setMarkerEnd: 'arrow'.! !

!XPDLTransitionNode methodsFor: '*orbeonBizagiSvgConverter' stamp: 'brunobb 02/11/2018 14:32'!
drawOn: aJasvgiBpmCanvas color: color
	| transition |

	transition := 
		aJasvgiBpmCanvas 
			connectWith: coordinates
			color: color
			widthPx: '1px'.

	transition setMarkerEnd: 'arrow'! !

!XPDLEndNode methodsFor: '*orbeonBizagiSvgConverter' stamp: 'brunobb 08/01/2017 05:34'!
drawOn: aJasvgiBpmCanvas

	^aJasvgiBpmCanvas drawEndNamed: self getName at: self getXcoordinate @ self getYcoordinate! !

Object subclass: #XpdlSvgConverter
	instanceVariableNames: 'xpdlString'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OrbeonBizagiSvgConverter'!

XpdlSvgConverter subclass: #BizagiSvgConverter
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OrbeonBizagiSvgConverter'!

!XpdlSvgConverter class methodsFor: 'other' stamp: 'BrunoBB 09/10/2016 07:33'!
convert: xpdlString

	^super new initialize
		xpdlString: xpdlString;
		yourself! !

!XpdlSvgConverter methodsFor: 'other' stamp: 'brunobb 10/16/2017 07:46'!
generateSVGFor: aBpmDefinition
	"The receiver answer a SVG string for BPM process <aBpmDefinition>"
	| xpdlReader svgCanvas |

	xpdlReader := XPDLReader2 forProcessNamed: 'convert' withString: xpdlString.
	svgCanvas := self getSVGCanvasClass newWidth: '1000px' height: '1000px'.
	svgCanvas addMarker: (svgCanvas markerClass newArrowAt: 10@5 id: 'arrow' width: 10 height:10).

	svgCanvas drawText: (self getSVGTitleForDefinition: aBpmDefinition) at: 20@20 textSizePx: '14px'.

	xpdlReader getAllWorkflows do: [:eachWorkflow | 
		eachWorkflow parentLanes do: [:eachLaneNode | eachLaneNode drawOn: svgCanvas].
		eachWorkflow transitions do: [:eachTransition | eachTransition drawOn: svgCanvas].
		eachWorkflow activities do: [:eachActivityNode | eachActivityNode drawOn: svgCanvas].
	].

	xpdlReader getAllWorkflows do: [:eachWorkflow | | gatewayText yCoordinate text |
		yCoordinate := eachWorkflow getLaneMaxYCoordinate + 20.
		eachWorkflow getGatewayNodes do: [:gatewayNode | 
			(gatewayNode outTransitions select: [:each | each hasCondition]) do: [:trNode | 
				gatewayText := gatewayNode getName, ' - ', trNode startCondition.
				text := svgCanvas drawText: gatewayText at: 10 @ yCoordinate.
				svgCanvas addFigure: text toGroup: svgCanvas defaultNameForProcessGroup.
				yCoordinate := yCoordinate + 20.
			].
		].
		eachWorkflow getTimerNodes do: [:timerNode |
			text := svgCanvas drawText: (timerNode getName, ' - ' , timerNode getActivationBlockValue) at: 10 @ yCoordinate.
			svgCanvas addFigure: text toGroup: svgCanvas defaultNameForProcessGroup.
			yCoordinate := yCoordinate + 20.
		].
	].
	^svgCanvas contents! !

!XpdlSvgConverter methodsFor: 'other' stamp: 'brunobb 02/06/2018 16:06'!
generateSVGFor: aBpmUser assignment: aBpmTaskAssignment
	| xpdlReader svgCanvas yCoordinate |

	xpdlReader := XPDLReader2 forProcessNamed: 'convert' withString: xpdlString.
	svgCanvas := self getSVGCanvasClass newWidth: '1000px' height: '1000px'.
	svgCanvas addMarker: (svgCanvas markerClass newArrowAt: 10@5 id: 'arrow' width: 10 height:10).

	svgCanvas drawText: (self getSVGTitleForAssignment: aBpmTaskAssignment) at: 20@20 textSizePx: '14px'.

	xpdlReader getAllWorkflows do: [:eachWorkflow | 
		eachWorkflow parentLanes do: [:eachLaneNode | eachLaneNode drawOn: svgCanvas].
		eachWorkflow activities do: [:eachActivityNode | | color stroke |
			color := aBpmTaskAssignment process getColorForActivityNamed: eachActivityNode getName user: aBpmUser.
			stroke := aBpmTaskAssignment process getStrokeForActivityNamed: eachActivityNode getName user: aBpmUser.
			eachActivityNode drawOn: svgCanvas color: color stroke: stroke].
		eachWorkflow transitions do: [:eachTransition | | color | 
			color := aBpmTaskAssignment process getColorForTransition: eachTransition user: aBpmUser.
			eachTransition drawOn: svgCanvas color: color].
	].
	"draw transition conditions at the bottom of the SVG"
	xpdlReader getAllWorkflows do: [:eachWorkflow | | gatewayText text |
		yCoordinate := eachWorkflow getLaneMaxYCoordinate + 20.
		eachWorkflow getGatewayNodes do: [:gatewayNode | 
			(gatewayNode outTransitions select: [:each | each hasCondition]) do: [:trNode | 
				gatewayText := gatewayNode getName, ' - ', trNode startCondition.
				text := svgCanvas drawText: gatewayText at: 10 @ yCoordinate.
				svgCanvas addFigure: text toGroup: svgCanvas defaultNameForProcessGroup.
				yCoordinate := yCoordinate + 20.
			].
		].
		"draw timer block code at the bottom of the SVG"
		eachWorkflow getTimerNodes do: [:timerNode |
			text := svgCanvas drawText: (timerNode getName, ' - ' , timerNode getActivationBlockValue) at: 10 @ yCoordinate.
			svgCanvas addFigure: text toGroup: svgCanvas defaultNameForProcessGroup.
			yCoordinate := yCoordinate + 20.
		].
	].

	aBpmTaskAssignment process getAllScriptVariables keysAndValuesDo: [:varName :value | | text |
		text := svgCanvas drawText: (varName, ': ', value printString) at: 10 @ yCoordinate.
		svgCanvas addFigure: text toGroup: svgCanvas defaultNameForProcessGroup.
		yCoordinate := yCoordinate + 20.
	].

	aBpmTaskAssignment process externalVariables keysAndValuesDo: [:varName :value | | text |
		text := svgCanvas drawText: (varName, ': ', value printString) at: 10 @ yCoordinate.
		svgCanvas addFigure: text toGroup: svgCanvas defaultNameForProcessGroup.
		yCoordinate := yCoordinate + 20.
	].
 
	^svgCanvas contents! !

!XpdlSvgConverter methodsFor: 'other' stamp: 'brunobb 02/06/2018 16:59'!
generateSVGFor: aBpmUser process: aBpmProcessInstance
	| xpdlReader svgCanvas yCoordinate|

	xpdlReader := XPDLReader2 forProcessNamed: 'convert' withString: xpdlString.
	svgCanvas := self getSVGCanvasClass newWidth: '1000px' height: '1000px'.
	svgCanvas addMarker: (svgCanvas markerClass newArrowAt: 10@5 id: 'arrow' width: 10 height:10).

	svgCanvas drawText: (self getSVGTitleForProcess: aBpmProcessInstance) at: 20@20 textSizePx: '14px'.

	xpdlReader getAllWorkflows do: [:eachWorkflow | 
		eachWorkflow parentLanes do: [:eachLaneNode | eachLaneNode drawOn: svgCanvas].
		eachWorkflow activities do: [:eachActivityNode | | color stroke |
			color := aBpmProcessInstance getColorForActivityNamed: eachActivityNode getName user: aBpmUser.
			stroke := aBpmProcessInstance getStrokeForActivityNamed: eachActivityNode getName user: aBpmUser.
			eachActivityNode drawOn: svgCanvas color: color stroke: stroke].
		eachWorkflow transitions do: [:eachTransition | | color | 
			color := aBpmProcessInstance getColorForTransition: eachTransition user: aBpmUser.
			eachTransition drawOn: svgCanvas color: color].
	].

	xpdlReader getAllWorkflows do: [:eachWorkflow | | gatewayText  text |
		yCoordinate := eachWorkflow getLaneMaxYCoordinate + 20.
		eachWorkflow getGatewayNodes do: [:gatewayNode | 
			(gatewayNode outTransitions select: [:each | each hasCondition]) do: [:trNode | 
				gatewayText := gatewayNode getName, ' - ', trNode startCondition.
				text := svgCanvas drawText: gatewayText at: 10 @ yCoordinate.
				svgCanvas addFigure: text toGroup: svgCanvas defaultNameForProcessGroup.
				yCoordinate := yCoordinate + 20.
			].
		].
		eachWorkflow getTimerNodes do: [:timerNode |
			text := svgCanvas drawText: (timerNode getName, ' - ' , timerNode getActivationBlockValue) at: 10 @ yCoordinate.
			svgCanvas addFigure: text toGroup: svgCanvas defaultNameForProcessGroup.
			yCoordinate := yCoordinate + 20.
		].
	].

	aBpmProcessInstance getAllScriptVariables keysAndValuesDo: [:varName :value | | text |
		text := svgCanvas drawText: (varName, ': ', value printString) at: 10 @ yCoordinate.
		svgCanvas addFigure: text toGroup: svgCanvas defaultNameForProcessGroup.
		yCoordinate := yCoordinate + 20.
	].

	aBpmProcessInstance externalVariables keysAndValuesDo: [:varName :value | | text |
		text := svgCanvas drawText: (varName, ': ', value printString) at: 10 @ yCoordinate.
		svgCanvas addFigure: text toGroup: svgCanvas defaultNameForProcessGroup.
		yCoordinate := yCoordinate + 20.
	].
	^svgCanvas contents! !

!XpdlSvgConverter methodsFor: 'other' stamp: 'BrunoBB 12/05/2016 10:55'!
generateSVGForTransition: aBpmTransitionDefinition
	"The receiver generate a SVG string based on transition <aBpmTransitionDefinition>"
	| svgCanvas |

	svgCanvas := self getSVGCanvasClass newWidth: '450px' height: '200px'.

	aBpmTransitionDefinition startArtifact drawFirstOn: svgCanvas.

	aBpmTransitionDefinition endArtifact drawLastOn: svgCanvas.

	aBpmTransitionDefinition drawOn: svgCanvas.

	^svgCanvas contents! !

!XpdlSvgConverter methodsFor: 'other' stamp: 'BrunoBB 12/04/2016 13:01'!
getSVGCanvasClass

	^JASVGIBpmCanvas! !

!XpdlSvgConverter methodsFor: 'other' stamp: 'BrunoBB 09/13/2016 14:59'!
getSVGTitleForAssignment: aBpmTaskAssignment

	^'#', aBpmTaskAssignment processId printString, 
		' | Process Name: ', aBpmTaskAssignment processName,
		' | User: ', aBpmTaskAssignment printUserName,
		' | State: ', aBpmTaskAssignment printProcessState,
		' | Creation: ', aBpmTaskAssignment printAssignmentDate! !

!XpdlSvgConverter methodsFor: 'other' stamp: 'BrunoBB 09/13/2016 15:00'!
getSVGTitleForDefinition: aBpmProcessDefinition

	^'#', aBpmProcessDefinition processId printString, 
		' | Process Name: ', aBpmProcessDefinition processName! !

!XpdlSvgConverter methodsFor: 'other' stamp: 'brunobb 01/13/2018 14:51'!
getSVGTitleForProcess: aBpmProcessInstance

	^'#', aBpmProcessInstance id printString, 
		' | Process Name: ', aBpmProcessInstance processName,
		' | State: ', aBpmProcessInstance printProcessState,
		' | Creation: ', aBpmProcessInstance createdTime printString! !

!XpdlSvgConverter methodsFor: 'Accessing' stamp: 'BrunoBB 09/10/2016 07:32'!
xpdlString
	^xpdlString! !

!XpdlSvgConverter methodsFor: 'Updating' stamp: 'BrunoBB 09/10/2016 07:32'!
xpdlString: newValue
	xpdlString := newValue! !

JASVGICanvas subclass: #JASVGIBpmCanvas
	instanceVariableNames: 'namesAndTags'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'OrbeonBizagiSvgConverter'!

!JASVGIBpmCanvas class methodsFor: 'other' stamp: 'BrunoBB 09/11/2016 12:22'!
defaultNameForProcessGroup

	^'process'! !

!JASVGIBpmCanvas class methodsFor: 'other' stamp: 'BrunoBB 12/04/2016 12:58'!
example1
	| jasv line |

	jasv := self newWidth: '400px' height: '400px'.
	jasv addMarker: 
		(self markerClass newArrowAt: 10@5 id: 'arrow' width: 10 height:10).

	jasv drawStartNamed: 'start' at: 30@30.
	jasv drawActivityNamed: 'Task 1' at: 200@30.
	jasv drawActivityNamed: 'Task 2' at: 60@90.
	jasv drawEndNamed: 'end' at: 300@300.

	line := jasv connect: (jasv getJasvgiTagNamed: 'start') to:  (jasv getJasvgiTagNamed: 'Task 1').
	line setMarkerEnd: 'arrow'.
	line := jasv connect: (jasv getJasvgiTagNamed: 'start') to:  (jasv getJasvgiTagNamed: 'Task 2').
	line setMarkerEnd: 'arrow'.

	line := jasv connect: (jasv getJasvgiTagNamed: 'Task 1') to:  (jasv getJasvgiTagNamed: 'end').
	line setMarkerEnd: 'arrow'.
	line := jasv connect: (jasv getJasvgiTagNamed: 'Task 2') to:  (jasv getJasvgiTagNamed: 'end').
	line setMarkerEnd: 'arrow'.

	jasv contents.! !

!JASVGIBpmCanvas class methodsFor: 'other' stamp: 'BrunoBB 12/04/2016 12:58'!
example2
	| jasv line |

	jasv := self newWidth: '500px' height: '400px'.
	jasv addMarker: 
		(self markerClass newArrowAt: 10@5 id: 'arrow' width: 10 height:10).

	jasv drawStartNamed: 'start' at: 30@30.
	jasv drawActivityNamed: 'Task 1' at: 80@30.
	jasv drawGatewayAt: 250@45 id: 'g1'.
	jasv drawActivityNamed: 'Task 2' at: 320@30.
	jasv drawActivityNamed: 'Task 3' at: 100@150.
	jasv drawEndNamed: 'end' at: 290@180.

	line := jasv connect: (jasv getJasvgiTagNamed: 'start') to:  (jasv getJasvgiTagNamed: 'Task 1').
	line setMarkerEnd: 'arrow'.
	line := jasv connect: (jasv getJasvgiTagNamed: 'Task 1') to:  (jasv getJasvgiTagNamed: 'g1').
	line setMarkerEnd: 'arrow'.

	line := jasv connect: (jasv getJasvgiTagNamed: 'g1') to:  (jasv getJasvgiTagNamed: 'Task 2').
	line setMarkerEnd: 'arrow'.
	line := jasv connect: (jasv getJasvgiTagNamed: 'g1') to:  (jasv getJasvgiTagNamed: 'Task 3').
	line setMarkerEnd: 'arrow'.
	line := jasv connect: (jasv getJasvgiTagNamed: 'Task 2') to:  (jasv getJasvgiTagNamed: 'end').
	line setMarkerEnd: 'arrow'.
	line := jasv connect: (jasv getJasvgiTagNamed: 'Task 3') to:  (jasv getJasvgiTagNamed: 'end').
	line setMarkerEnd: 'arrow'.
	jasv contents.! !

!JASVGIBpmCanvas class methodsFor: 'other' stamp: 'BrunoBB 12/04/2016 12:59'!
example3
	| jasv line |

	jasv := self newWidth: '400px' height: '400px'.
	jasv addMarker: 
		(self markerClass newArrowAt: 10@5 id: 'arrow' width: 10 height:10).

	jasv drawRoundRectangleAt: 300@180 id: 'rect1' width: 90 height: 60 stroke: 'red' fillColor: 'green'.
	(jasv drawGatewayAt: 10@100 id: 'rect2' height: 40 width: 40 fillColor: 'lightblue' stroke: 'black').
	jasv drawRoundRectangleAt: 30@200 id: 'rect3' width: 90 height: 60 stroke: 'blue' fillColor: 'red'.

	line := jasv connect: (jasv getSvgObjectId: 'rect1') to:  (jasv getSvgObjectId: 'rect2').
	line setMarkerEnd: 'arrow'.
	line := jasv connect: (jasv getSvgObjectId: 'rect3') to:  (jasv getSvgObjectId: 'rect2').
	line setMarkerEnd: 'arrow'.
	jasv contents.! !

!JASVGIBpmCanvas methodsFor: 'activities' stamp: 'BrunoBB 01/13/2017 06:15'!
cancelDefaultGroupTranslation

	(svgGroups at: self defaultNameForProcessGroup ifAbsent: [^self]) transform: 'translate(0,0)'! !

!JASVGIBpmCanvas methodsFor: 'connections' stamp: 'BrunoBB 09/11/2016 07:16'!
connect: figureOne to: figureTwo

	^self connect: figureOne to: figureTwo color: 'black'! !

!JASVGIBpmCanvas methodsFor: 'connections' stamp: 'BrunoBB 09/11/2016 07:16'!
connect: figureOne to: figureTwo color: color

	^self connect: figureOne to: figureTwo color: color stroke: color widthPx: '1px'! !

!JASVGIBpmCanvas methodsFor: 'connections' stamp: 'BrunoBB 09/11/2016 11:57'!
connect: figureOne to: figureTwo color: color stroke: stroke widthPx: widthPx
	| line |

	line := self drawLineFrom: (figureOne getPointToConnectTo: figureTwo) 
					to: (figureTwo getPointToConnectTo: figureOne) 
					id: UUID new asString
					widthPx: widthPx
					stroke: stroke 
					fillColor: color.

	self addFigure: line toGroup: self defaultNameForProcessGroup.

	^line! !

!JASVGIBpmCanvas methodsFor: 'connections' stamp: 'BrunoBB 09/11/2016 07:15'!
connect: figureOne to: figureTwo color: color widthPx: widthPx

	^self connect: figureOne to: figureTwo color: color stroke: color widthPx: widthPx! !

!JASVGIBpmCanvas methodsFor: 'connections' stamp: 'BrunoBB 09/12/2016 14:06'!
connectWith: coordinates color: color widthPx: widthPx
	| path |

	path := self drawLineM: coordinates id: UUID new asString widthPx: widthPx stroke: color fillColor: 'none'.

	self addFigure: path toGroup: self defaultNameForProcessGroup.

	^path! !

!JASVGIBpmCanvas methodsFor: 'connections' stamp: 'BrunoBB 09/12/2016 14:22'!
connectWith: coordinates color: color widthPx: widthPx condition: condition
	| path text |

	path := self drawLineM: coordinates id: UUID new asString widthPx: widthPx stroke: color fillColor: 'none'.

	text := self drawText: condition at: coordinates first textSizePx: self defaultTransitionConditionSize.

	self addFigure: path toGroup: self defaultNameForProcessGroup.
	self addFigure: text toGroup: self defaultNameForProcessGroup.

	^path! !

!JASVGIBpmCanvas methodsFor: 'draw' stamp: 'brunobb 08/01/2017 06:01'!
contents

	svgTag with: [
		self tag: 'defs' with: [svgMarkers do: [:each | each drawOn: self]].
		(svgGroups orderedKeys select: [:e | e notNil]) do:[:key | | tagGroup |
			tagGroup := svgGroups at: key.
			tagGroup drawOn: self.
		].
		(svgFigures orderedKeys select: [:e | e notNil]) do:[:key | | svgFigureTag |
			svgFigureTag := svgFigures at: key.
			svgFigureTag drawOn: self.
		].
		(svgLines orderedKeys select: [:e | e notNil]) do:[:key | | svgLineTag |
			svgLineTag := svgLines at: key.
			svgLineTag drawOn: self.
		].
	].

	^xmlCanvas contents! !

!JASVGIBpmCanvas methodsFor: 'draw' stamp: 'BrunoBB 09/13/2016 03:57'!
createDefaultGroup
	| group |

	group := JASVGITagGroup newNamed: self defaultNameForProcessGroup.
	group transform: 'translate(0,50)'.

	^svgGroups at: self defaultNameForProcessGroup put: group! !

!JASVGIBpmCanvas methodsFor: 'default values' stamp: 'BrunoBB 09/12/2016 14:24'!
defaultActivityNameSize

	^'14px'! !

!JASVGIBpmCanvas methodsFor: 'default values' stamp: 'BrunoBB 09/10/2016 06:03'!
defaultEndEventFillColor

	^'red'! !

!JASVGIBpmCanvas methodsFor: 'default values' stamp: 'brunobb 08/01/2017 12:56'!
defaultEventFillColor

	^'lightblue'! !

!JASVGIBpmCanvas methodsFor: 'default values' stamp: 'BrunoBB 09/10/2016 05:42'!
defaultEventHeight

	^40! !

!JASVGIBpmCanvas methodsFor: 'default values' stamp: 'BrunoBB 09/12/2016 14:21'!
defaultEventNameSize

	^'12px'! !

!JASVGIBpmCanvas methodsFor: 'default values' stamp: 'BrunoBB 09/10/2016 05:43'!
defaultEventWidth

	^40! !

!JASVGIBpmCanvas methodsFor: 'default values' stamp: 'BrunoBB 09/10/2016 06:42'!
defaultGatewayFillColor

	^'lightgray'! !

!JASVGIBpmCanvas methodsFor: 'default values' stamp: 'BrunoBB 09/10/2016 06:43'!
defaultGatewayHeight

	^30! !

!JASVGIBpmCanvas methodsFor: 'default values' stamp: 'BrunoBB 09/12/2016 14:22'!
defaultGatewayNameSize

	^'12px'! !

!JASVGIBpmCanvas methodsFor: 'default values' stamp: 'BrunoBB 09/10/2016 07:08'!
defaultGatewayStroke

	^'darkred'! !

!JASVGIBpmCanvas methodsFor: 'default values' stamp: 'BrunoBB 09/10/2016 06:43'!
defaultGatewayWidth

	^30! !

!JASVGIBpmCanvas methodsFor: 'default values' stamp: 'BrunoBB 09/11/2016 08:09'!
defaultLaneColor

	^'none'! !

!JASVGIBpmCanvas methodsFor: 'default values' stamp: 'BrunoBB 09/11/2016 07:47'!
defaultLaneStroke

	^'black'! !

!JASVGIBpmCanvas methodsFor: 'other' stamp: 'BrunoBB 09/11/2016 12:22'!
defaultNameForProcessGroup

	^self class defaultNameForProcessGroup! !

!JASVGIBpmCanvas methodsFor: 'default values' stamp: 'BrunoBB 09/11/2016 15:54'!
defaultStartEventFillColor

	^'lightgreen'! !

!JASVGIBpmCanvas methodsFor: 'default values' stamp: 'BrunoBB 09/06/2016 10:21'!
defaultTaskFillColor

	^'lightsteelblue'! !

!JASVGIBpmCanvas methodsFor: 'default values' stamp: 'BrunoBB 09/10/2016 08:47'!
defaultTaskHeight

	^40! !

!JASVGIBpmCanvas methodsFor: 'default values' stamp: 'BrunoBB 09/06/2016 10:21'!
defaultTaskStroke

	^'darkblue'! !

!JASVGIBpmCanvas methodsFor: 'default values' stamp: 'BrunoBB 09/10/2016 08:47'!
defaultTaskWidth

	^100! !

!JASVGIBpmCanvas methodsFor: 'default values' stamp: 'BrunoBB 09/12/2016 14:22'!
defaultTransitionConditionSize

	^'10px'! !

!JASVGIBpmCanvas methodsFor: 'default values' stamp: 'BrunoBB 09/10/2016 06:04'!
defultEndEventStroke

	^'darkblue'! !

!JASVGIBpmCanvas methodsFor: 'default values' stamp: 'brunobb 08/01/2017 13:24'!
defultEventStroke

	^'gray'! !

!JASVGIBpmCanvas methodsFor: 'default values' stamp: 'BrunoBB 09/10/2016 05:42'!
defultStartEventStroke

	^'darkblue'! !

!JASVGIBpmCanvas methodsFor: 'activities' stamp: 'brunobb 08/01/2017 12:14'!
drawActivityNamed: aString at: aPoint

	^self drawActivityNamed: aString at: aPoint color: self defaultTaskFillColor! !

!JASVGIBpmCanvas methodsFor: 'activities' stamp: 'BrunoBB 09/10/2016 14:58'!
drawActivityNamed: aString at: aPoint color: color

	^self drawActivityNamed: aString at: aPoint color: color stroke: self defaultTaskStroke! !

!JASVGIBpmCanvas methodsFor: 'activities' stamp: 'BrunoBB 09/12/2016 10:16'!
drawActivityNamed: aString at: aPoint color: color stroke: stroke

	^self drawActivityNamed: aString at: aPoint extent: (self defaultTaskWidth @ self defaultTaskHeight) color: color stroke: stroke! !

!JASVGIBpmCanvas methodsFor: 'activities' stamp: 'BrunoBB 09/14/2016 05:22'!
drawActivityNamed: aString at: aPoint extent: extentPoint

	^self drawActivityNamed: aString at: aPoint extent: extentPoint color: self defaultTaskFillColor stroke: self defaultTaskStroke! !

!JASVGIBpmCanvas methodsFor: 'activities' stamp: 'BrunoBB 01/13/2017 09:13'!
drawActivityNamed: aString at: aPoint extent: extent color: color stroke: stroke

	^self drawActivityNamed: aString at: aPoint extent: extent color: color stroke: stroke textSizePx: self defaultActivityNameSize! !

!JASVGIBpmCanvas methodsFor: 'activities' stamp: 'BrunoBB 01/13/2017 09:11'!
drawActivityNamed: aString at: aPoint extent: extent color: color stroke: stroke textSizePx: nameSizePx
	| rect textPoint |

	rect := self drawRoundRectangleAt: aPoint 
						width: extent x 
						height: extent y 
						stroke: stroke
						fillColor: color.

	textPoint := (aPoint x + 5) @ (aPoint y + 32).

	namesAndTags at: aString put: rect. "map the Activity name with the Activity id"

	self addFigure: rect toGroup: self defaultNameForProcessGroup.
	self addFigure: (self drawText: aString at: textPoint textSizePx: nameSizePx) toGroup: self defaultNameForProcessGroup.

	^rect! !

!JASVGIBpmCanvas methodsFor: 'events' stamp: 'BrunoBB 09/30/2016 09:55'!
drawEndNamed: aString at: aPoint
	| end textPoint |
	"aPoint + 15 >> to fix a mismatch with Bizagi coordinates"
	end := self drawCircleAt: aPoint + 15 r: 15 strokeWidth: '3' stroke: self defultEndEventStroke fillColor: self defaultEndEventFillColor.

	textPoint := (aPoint x + (self defaultEventWidth // 3)) @ (aPoint y + (self defaultEventHeight // 2)).

	namesAndTags at: aString put: end. "map the Activity name with the Activity id"

	self addFigure: end toGroup: self defaultNameForProcessGroup.
	self addFigure: (self drawText: aString at: end position textSizePx: self defaultEventNameSize) toGroup: self defaultNameForProcessGroup.

	^end! !

!JASVGIBpmCanvas methodsFor: 'events' stamp: 'brunobb 08/01/2017 12:52'!
drawEventNamed: aString at: aPoint
	
	^self drawEventNamed: aString at: aPoint radius: 15! !

!JASVGIBpmCanvas methodsFor: 'events' stamp: 'brunobb 08/01/2017 13:21'!
drawEventNamed: aString at: aPoint radius: radius
	
	^self drawEventNamed: aString at: aPoint radius: radius stroke: self defultEventStroke! !

!JASVGIBpmCanvas methodsFor: 'events' stamp: 'brunobb 08/01/2017 13:29'!
drawEventNamed: aString at: aPoint radius: radius stroke: stroke

	^self drawEventNamed: aString at: aPoint radius: radius stroke: stroke color: self defaultEventFillColor! !

!JASVGIBpmCanvas methodsFor: 'events' stamp: 'brunobb 08/01/2017 13:29'!
drawEventNamed: aString at: aPoint radius: radius stroke: stroke color: color
	| event textPoint |
	"aPoint + 15 >> to fix a mismatch with Bizagi coordinates"

	event := self drawCircleAt: aPoint r: radius strokeWidth: '2' stroke: stroke fillColor: color.
	"event id: aString."

	textPoint := (aPoint x + (self defaultEventWidth // 3)) @ (aPoint y + (self defaultEventHeight // 2)).

	namesAndTags at: aString put: event. "map the Activity name with the Activity id"

	self addFigure: event toGroup: self defaultNameForProcessGroup.
	self addFigure: (self drawText: aString at: textPoint textSizePx: self defaultEventNameSize) toGroup: self defaultNameForProcessGroup.

	^event! !

!JASVGIBpmCanvas methodsFor: 'gateways' stamp: 'BrunoBB 09/10/2016 08:23'!
drawGatewayAt: aPoint

	^self drawGatewayAt: aPoint id: UUID new asString! !

!JASVGIBpmCanvas methodsFor: 'gateways' stamp: 'BrunoBB 09/13/2016 10:10'!
drawGatewayAt: aPoint color: color

	^self drawGatewayAt: aPoint id: UUID new asString color: color! !

!JASVGIBpmCanvas methodsFor: 'gateways' stamp: 'BrunoBB 09/11/2016 11:52'!
drawGatewayAt: aPoint id: id

	^self drawGatewayAt: aPoint 
			id: id 
			height: self defaultGatewayHeight 
			width: self defaultGatewayWidth
			fillColor: self defaultGatewayFillColor
			stroke: self defaultGatewayStroke! !

!JASVGIBpmCanvas methodsFor: 'gateways' stamp: 'BrunoBB 09/12/2016 08:45'!
drawGatewayAt: aPoint id: id color: color

	^self drawGatewayAt: aPoint 
			id: id 
			height: self defaultGatewayHeight 
			width: self defaultGatewayWidth
			fillColor: color
			stroke: self defaultGatewayStroke! !

!JASVGIBpmCanvas methodsFor: 'gateways' stamp: 'BrunoBB 10/01/2016 08:58'!
drawGatewayAt: aPoint id: id height: height width: width fillColor: fillColor stroke: stroke
	| figure rotation textPoint |
	"aPoint + 5 >> to fix a mismatch with Bizagi coordinates"
	figure := JASVGITagRectangle newAt: aPoint + 5 id: id width: width height: height stroke: stroke fillColor: fillColor.

	rotation := 'rotate(-45 ', figure center x printString, ' ', figure center y printString, ')'.
	figure transform: rotation.

	textPoint := aPoint x @ (aPoint y - 10).

	namesAndTags at: id put: figure. "map the Gateway name with the Gateway id"

	self draw: figure.

	self addFigure: figure toGroup: self defaultNameForProcessGroup.
	self addFigure: (self drawText: id at: textPoint textSizePx: self defaultGatewayNameSize) toGroup: self defaultNameForProcessGroup.

	^figure! !

!JASVGIBpmCanvas methodsFor: 'gateways' stamp: 'BrunoBB 09/30/2016 09:53'!
drawGatewayIconFor: type at: aPoint height: height width: width
	| center |

	center := (aPoint x + (width // 2)) @ (aPoint y + (height // 2)) + 5.

	(type = 'Inclusive') ifTrue: [
		^self addFigure: (self drawCircleAt: center r: 10 strokeWidth: '3px' stroke: 'black' fillColor: 'none') toGroup: self defaultNameForProcessGroup].

	(type = 'Parallel')
	ifTrue: [| lineH lineV |
		lineH := self drawLineFrom: ((center x - 10) @ center y) to: ((center x + 10) @ center y) widthPx: '3px' stroke: 'black' fillColor: 'black'.
		lineV := self drawLineFrom: (center x @ (center y - 10)) to: (center x @ (center y + 10)) widthPx: '3px' stroke: 'black' fillColor: 'black'.
		self addFigure: lineV toGroup: self defaultNameForProcessGroup.
		^self addFigure: lineH toGroup: self defaultNameForProcessGroup].

	(type = '' "Exclusive")
	ifTrue: [| lineD1 lineD2 |
		lineD1 := self drawLineFrom: ((center x - 7) @ (center y - 7)) to: ((center x + 7) @ (center y + 7)) widthPx: '3px' stroke: 'black' fillColor: 'black'.
		lineD2 := self drawLineFrom: ((center x - 7) @ (center y + 7)) to: ((center x + 7) @ (center y - 7)) widthPx: '3px' stroke: 'black' fillColor: 'black'.
		self addFigure: lineD1 toGroup: self defaultNameForProcessGroup.
		^self addFigure: lineD2 toGroup: self defaultNameForProcessGroup].

	^self addFigure: (self drawCircleAt: center r: 10 fillColor: 'red' stroke: 'red') toGroup: self defaultNameForProcessGroup! !

!JASVGIBpmCanvas methodsFor: 'gateways' stamp: 'BrunoBB 09/13/2016 13:32'!
drawGatewayType: type at: aPoint id: id color: color

	^self drawGatewayType: type 
			at: aPoint 
			id: id 
			height: self defaultGatewayHeight 
			width: self defaultGatewayWidth
			fillColor: color 
			stroke: self defaultGatewayStroke! !

!JASVGIBpmCanvas methodsFor: 'gateways' stamp: 'BrunoBB 10/01/2016 08:58'!
drawGatewayType: type at: aPoint id: id height: height width: width fillColor: fillColor stroke: stroke
	| figure rotation textPoint |
	"aPoint + 5 >> to fix a mismatch with Bizagi coordinates"
	figure := JASVGITagRectangle newAt: aPoint + 5 id: id width: width height: height stroke: stroke fillColor: fillColor.

	rotation := 'rotate(-45 ', figure center x printString, ' ', figure center y printString, ')'.
	figure transform: rotation.

	textPoint := aPoint x @ (aPoint y - 10).

	namesAndTags at: id put: figure. "map the Gateway name with the Gateway id"

	self draw: figure.

	self addFigure: figure toGroup: self defaultNameForProcessGroup.
	self addFigure: (self drawGatewayIconFor: type at: aPoint height: height width: width) toGroup: self defaultNameForProcessGroup.
	self addFigure: (self drawText: id at: textPoint textSizePx: self defaultGatewayNameSize) toGroup: self defaultNameForProcessGroup.

	^figure! !

!JASVGIBpmCanvas methodsFor: 'lanes' stamp: 'BrunoBB 09/11/2016 07:46'!
drawLaneNamed: aString at: aPoint width: width height: height

	^self drawLaneNamed: aString at: aPoint width: width height: height color: self defaultLaneColor stroke: self defaultLaneStroke! !

!JASVGIBpmCanvas methodsFor: 'lanes' stamp: 'BrunoBB 09/28/2016 08:29'!
drawLaneNamed: aString at: aPoint width: width height: height color: color stroke: stroke
	| rect roleRect laneName laneNameCenter |

	laneNameCenter := ((aPoint x - 20) @ (aPoint y + (height // 2) + 35)).
	rect := self drawRectangleAt: aPoint width: width height: height stroke: stroke fillColor: color.
	roleRect := self drawRectangleAt: ((aPoint x - 50) @ aPoint y) width: 50 height: height stroke: stroke fillColor: color.
	laneName := self drawText: aString at: laneNameCenter textSizePx: '14px'.

	laneName transform: 'rotate(-90 ', laneNameCenter x printString, ' ', laneNameCenter y printString, ')'.

	namesAndTags at: aString put: rect. "map the Activity name with the Activity id"

	self addFigure: roleRect toGroup: self defaultNameForProcessGroup.
	self addFigure: rect toGroup: self defaultNameForProcessGroup.
	self addFigure: laneName toGroup: self defaultNameForProcessGroup.

	^rect! !

!JASVGIBpmCanvas methodsFor: 'activities' stamp: 'BrunoBB 09/14/2016 05:21'!
drawMultiInstaceActivityNamed: aString at: aPoint extent: extent

	^self drawMultiInstaceActivityNamed: aString at: aPoint extent: extent color: self defaultTaskFillColor stroke: self defaultTaskStroke! !

!JASVGIBpmCanvas methodsFor: 'activities' stamp: 'BrunoBB 09/14/2016 05:29'!
drawMultiInstaceActivityNamed: aString at: aPoint extent: extent color: color stroke: stroke
	| rect center line1 line2 line3 |

	center := (aPoint x + (extent x // 2)) @ (aPoint y + (extent y // 2) + 20) .

	rect := self drawActivityNamed: aString at: aPoint extent: extent color: color stroke: stroke.

	line1 := self drawLineFrom: ((center x - 5) @ (center y - 5)) to: ((center x - 5) @ (center y + 5)) widthPx: '2px' stroke: 'black' fillColor: 'black'.
	line2 := self drawLineFrom: (center x  @ (center y - 5)) to: (center x @ (center y + 5)) widthPx: '2px' stroke: 'black' fillColor: 'black'.
	line3 := self drawLineFrom: ((center x + 5) @ (center y - 5)) to: ((center x + 5) @ (center y + 5)) widthPx: '2px' stroke: 'black' fillColor: 'black'.

	self addFigure: line1 toGroup: self defaultNameForProcessGroup.
	self addFigure: line2 toGroup: self defaultNameForProcessGroup.
	self addFigure: line3 toGroup: self defaultNameForProcessGroup.

	^rect! !

!JASVGIBpmCanvas methodsFor: 'activities' stamp: 'BrunoBB 01/13/2017 09:13'!
drawMultiInstaceActivityNamed: aString at: aPoint extent: extent color: color stroke: stroke textSizePx: nameSizePx
	| rect center line1 line2 line3 |

	center := (aPoint x + (extent x // 2)) @ (aPoint y + (extent y // 2) + 20) .

	rect := self drawActivityNamed: aString at: aPoint extent: extent color: color stroke: stroke textSizePx: nameSizePx.

	line1 := self drawLineFrom: ((center x - 5) @ (center y - 5)) to: ((center x - 5) @ (center y + 5)) widthPx: '2px' stroke: 'black' fillColor: 'black'.
	line2 := self drawLineFrom: (center x  @ (center y - 5)) to: (center x @ (center y + 5)) widthPx: '2px' stroke: 'black' fillColor: 'black'.
	line3 := self drawLineFrom: ((center x + 5) @ (center y - 5)) to: ((center x + 5) @ (center y + 5)) widthPx: '2px' stroke: 'black' fillColor: 'black'.

	self addFigure: line1 toGroup: self defaultNameForProcessGroup.
	self addFigure: line2 toGroup: self defaultNameForProcessGroup.
	self addFigure: line3 toGroup: self defaultNameForProcessGroup.

	^rect! !

!JASVGIBpmCanvas methodsFor: 'script' stamp: 'brunobb 08/01/2017 12:15'!
drawScriptNamed: aString at: aPoint

	^self drawScriptNamed: aString at: aPoint color: self defaultTaskFillColor! !

!JASVGIBpmCanvas methodsFor: 'script' stamp: 'brunobb 08/01/2017 12:15'!
drawScriptNamed: aString at: aPoint color: color

	^self drawScriptNamed: aString at: aPoint color: color stroke: self defaultTaskStroke! !

!JASVGIBpmCanvas methodsFor: 'script' stamp: 'brunobb 08/01/2017 12:16'!
drawScriptNamed: aString at: aPoint color: color stroke: stroke

	^self drawScriptNamed: aString at: aPoint extent: (self defaultTaskWidth @ self defaultTaskHeight) color: color stroke: stroke! !

!JASVGIBpmCanvas methodsFor: 'script' stamp: 'brunobb 08/01/2017 12:16'!
drawScriptNamed: aString at: aPoint extent: extentPoint

	^self drawScriptNamed: aString at: aPoint extent: extentPoint color: self defaultTaskFillColor stroke: self defaultTaskStroke! !

!JASVGIBpmCanvas methodsFor: 'script' stamp: 'brunobb 08/01/2017 12:15'!
drawScriptNamed: aString at: aPoint extent: extent color: color stroke: stroke

	^self drawScriptNamed: aString at: aPoint extent: extent color: color stroke: stroke textSizePx: self defaultActivityNameSize! !

!JASVGIBpmCanvas methodsFor: 'script' stamp: 'brunobb 08/01/2017 12:40'!
drawScriptNamed: aString at: aPoint extent: extent color: color stroke: stroke textSizePx: nameSizePx
	| rect textPoint scriptRect scriptLine1 scriptLine2 scriptLine3 scriptPoint1 scriptPoint2 scriptPoint3 |

	rect := self drawRoundRectangleAt: aPoint width: extent x height: extent y stroke: stroke fillColor: color.
	scriptRect := self drawRoundRectangleAt: (aPoint + 5) width: 10 height: 15 stroke: stroke fillColor: color.
	scriptPoint1 := (aPoint x + 7) @ (aPoint y + 9).
	scriptLine1 := self drawLineFrom: scriptPoint1 to: ((scriptPoint1 x + 6) @ scriptPoint1 y).
	scriptPoint2 := scriptPoint1 x @ (scriptPoint1 y + 3).
	scriptLine2 := self drawLineFrom: scriptPoint2 to: ((scriptPoint2 x + 6) @ scriptPoint2 y).
	scriptPoint3 := scriptPoint2 x @ (scriptPoint2 y + 3).
	scriptLine3 := self drawLineFrom: scriptPoint3 to: ((scriptPoint3 x + 6) @ scriptPoint3 y).

	textPoint := (aPoint x + 5) @ (aPoint y + 32).

	namesAndTags at: aString put: rect. "map the Activity name with the Activity id"

	self addFigure: rect toGroup: self defaultNameForProcessGroup.
	self addFigure: scriptRect toGroup: self defaultNameForProcessGroup.
	self addFigure: scriptLine1 toGroup: self defaultNameForProcessGroup.
	self addFigure: scriptLine2 toGroup: self defaultNameForProcessGroup.
	self addFigure: scriptLine3 toGroup: self defaultNameForProcessGroup.
	self addFigure: (self drawText: aString at: textPoint textSizePx: nameSizePx) toGroup: self defaultNameForProcessGroup.

	^rect! !

!JASVGIBpmCanvas methodsFor: 'events' stamp: 'BrunoBB 09/30/2016 09:53'!
drawStartNamed: aString at: aPoint
	| start textPoint |
	"aPoint + 15 >> to fix a mismatch with Bizagi coordinates"
	start := self drawCircleAt: aPoint + 15 r: 15 stroke: self defultStartEventStroke fillColor: self defaultStartEventFillColor .

	textPoint := (aPoint x + (self defaultEventWidth // 3)) @ (aPoint y + (self defaultEventHeight // 2)).

	namesAndTags at: aString put: start. "map the Activity name with the Activity id"

	self addFigure: start toGroup: self defaultNameForProcessGroup.
	self addFigure: (self drawText: aString at: start position textSizePx: self defaultEventNameSize) toGroup: self defaultNameForProcessGroup.

	^start! !

!JASVGIBpmCanvas methodsFor: 'activities' stamp: 'BrunoBB 09/14/2016 10:21'!
drawSubProcessActivityNamed: aString at: aPoint extent: extent

	^self drawSubProcessActivityNamed: aString at: aPoint extent: extent color: self defaultTaskFillColor stroke: self defaultTaskStroke! !

!JASVGIBpmCanvas methodsFor: 'activities' stamp: 'BrunoBB 10/01/2016 08:22'!
drawSubProcessActivityNamed: aString at: aPoint extent: extent color: color stroke: stroke
	| process center lineH lineV smallRect |

	center := (aPoint x + (extent x // 2)) @ (aPoint y + 15 + (extent y // 2)).

	process := self drawActivityNamed: aString at: aPoint extent: extent color: color stroke: stroke.

	lineH := self drawLineFrom: ((center x - 6) @ center y) to: ((center x + 6) @ center y) widthPx: '3px' stroke: 'black' fillColor: 'black'.
	lineV := self drawLineFrom: (center x @ (center y - 6)) to: (center x @ (center y + 6)) widthPx: '3px' stroke: 'black' fillColor: 'black'.
	smallRect := self drawRoundRectangleAt: center - 8 width: 16 height: 16 stroke: 'black' fillColor: 'none'.

	self addFigure: smallRect toGroup: self defaultNameForProcessGroup.
	self addFigure: lineH toGroup: self defaultNameForProcessGroup.
	self addFigure: lineV toGroup: self defaultNameForProcessGroup.

	^process! !

!JASVGIBpmCanvas methodsFor: 'activities' stamp: 'BrunoBB 01/13/2017 09:14'!
drawSubProcessActivityNamed: aString at: aPoint extent: extent color: color stroke: stroke textSizePx: nameSizePx
	| process center lineH lineV smallRect |

	center := (aPoint x + (extent x // 2)) @ (aPoint y + 15 + (extent y // 2)).

	process := self drawActivityNamed: aString at: aPoint extent: extent color: color stroke: stroke textSizePx: nameSizePx.

	lineH := self drawLineFrom: ((center x - 6) @ center y) to: ((center x + 6) @ center y) widthPx: '3px' stroke: 'black' fillColor: 'black'.
	lineV := self drawLineFrom: (center x @ (center y - 6)) to: (center x @ (center y + 6)) widthPx: '3px' stroke: 'black' fillColor: 'black'.
	smallRect := self drawRoundRectangleAt: center - 8 width: 16 height: 16 stroke: 'black' fillColor: 'none'.

	self addFigure: smallRect toGroup: self defaultNameForProcessGroup.
	self addFigure: lineH toGroup: self defaultNameForProcessGroup.
	self addFigure: lineV toGroup: self defaultNameForProcessGroup.

	^process! !

!JASVGIBpmCanvas methodsFor: 'activities' stamp: 'BrunoBB 01/13/2017 09:14'!
drawSubProcessActivityNamed: aString at: aPoint extent: extent textSizePx: nameSizePx

	^self drawSubProcessActivityNamed: aString at: aPoint extent: extent color: self defaultTaskFillColor stroke: self defaultTaskStroke textSizePx: nameSizePx! !

!JASVGIBpmCanvas methodsFor: 'events' stamp: 'brunobb 10/18/2017 14:29'!
drawTimeEvent: anXPDLEventNode at: aPoint
	| clockLine1 clockLine2 center |

	center := (anXPDLEventNode getWidth = 30)
		ifTrue: [(anXPDLEventNode getXcoordinate @ anXPDLEventNode getYcoordinate) + (anXPDLEventNode getWidth asNumber // 2)]
		ifFalse: [anXPDLEventNode getXcoordinate @ anXPDLEventNode getYcoordinate].

	self drawEventNamed: anXPDLEventNode getName at: center radius: (anXPDLEventNode getWidth asNumber // 2) stroke: self defultEventStroke color: '#90a5bd'.

	"render internal clock"
	self drawEventNamed: anXPDLEventNode getName at: center radius: ((anXPDLEventNode getWidth asNumber // 2) - 5) stroke: 'gray' color: '#d28247'.
	
	clockLine1 := self drawLineFrom: center to: ((center x + 9) @ center y) color: 'black'.
	clockLine2 := self drawLineFrom: center to: (center x @ (center y - 9)) color: 'black'.

	self addFigure: clockLine1 toGroup: self defaultNameForProcessGroup.
	self addFigure: clockLine2 toGroup: self defaultNameForProcessGroup.! !

!JASVGIBpmCanvas methodsFor: 'events' stamp: 'brunobb 08/01/2017 13:34'!
drawTimeEventNamed: aString at: aPoint
	| clockLine1 clockLine2 |

	self drawEventNamed: aString at: aPoint radius: 15 stroke: self defultEventStroke color: '#90a5bd'.

	"render internal clock"
	self drawEventNamed: aString at: aPoint radius: 10 stroke: 'gray' color: '#d28247'.
	
	clockLine1 := self drawLineFrom: aPoint to: ((aPoint x + 9) @ aPoint y) color: 'black'.
	clockLine2 := self drawLineFrom: aPoint to: (aPoint x @ (aPoint y - 9)) color: 'black'.

	self addFigure: clockLine1 toGroup: self defaultNameForProcessGroup.
	self addFigure: clockLine2 toGroup: self defaultNameForProcessGroup.! !

!JASVGIBpmCanvas methodsFor: 'other' stamp: 'BrunoBB 09/06/2016 10:26'!
getJasvgiTagNamed: aString

	^self getJasvgiTagNamed: aString ifAbsent: [nil]! !

!JASVGIBpmCanvas methodsFor: 'other' stamp: 'BrunoBB 09/10/2016 05:54'!
getJasvgiTagNamed: aString ifAbsent: aBlock

	^namesAndTags at: aString ifAbsent: aBlock! !

!JASVGIBpmCanvas methodsFor: 'other' stamp: 'BrunoBB 09/10/2016 08:34'!
getMarkerNamed: aString

	^svgMarkers at: aString ifAbsent: [nil]! !

!JASVGIBpmCanvas methodsFor: 'other' stamp: 'BrunoBB 09/11/2016 12:31'!
initialize

	super initialize.

	namesAndTags := Dictionary new.

	self createDefaultGroup.! !

!JASVGIBpmCanvas methodsFor: 'Accessing' stamp: 'BrunoBB 09/06/2016 10:21'!
namesAndTags
	^namesAndTags! !

!JASVGIBpmCanvas methodsFor: 'Updating' stamp: 'BrunoBB 09/06/2016 10:21'!
namesAndTags: newValue
	namesAndTags := newValue! !

!XPDLSubProcessNode methodsFor: '*orbeonBizagiSvgConverter' stamp: 'BrunoBB 09/14/2016 10:23'!
drawOn: aJasvgiBpmCanvas

	^aJasvgiBpmCanvas 
		drawSubProcessActivityNamed: self getName 
		at: self getXcoordinate @ self getYcoordinate 
		extent: self getWidth @ self getHeight! !

!XPDLSubProcessNode methodsFor: '*orbeonBizagiSvgConverter' stamp: 'BrunoBB 09/14/2016 10:25'!
drawOn: aJasvgiBpmCanvas color: color stroke: stroke 

	^aJasvgiBpmCanvas 
		drawSubProcessActivityNamed: self getName 
		at: self getXcoordinate @ self getYcoordinate
		extent: self getWidth @ self getHeight 
		color: color 
		stroke: stroke! !
